#ifndef ADVENT_DVEREB_FOLDER_H
#define ADVENT_DVEREB_FOLDER_H

#include "File.h"

#include <string>
#include <vector>

class Folder : public File {
public:
	Folder(const std::string &filename);

	unsigned long Size() const override;
	void AddFile(const std::string &filename, unsigned long size);
	void AddFolder(const std::string &name);
	const std::vector<File*>& Files() const;

private:
	std::vector<File*> files;
};

#endif
